/*
 * Copyright (C) 2014 iZc <nplusc.de>
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
 */
package de.nplusc.izc.izstreamer;

import java.awt.Canvas;
import java.io.File;
import javax.swing.JFrame;
import uk.co.caprica.vlcj.player.MediaPlayer;
import uk.co.caprica.vlcj.player.MediaPlayerFactory;
import uk.co.caprica.vlcj.player.embedded.EmbeddedMediaPlayer;
import uk.co.caprica.vlcj.player.embedded.videosurface.CanvasVideoSurface;
import uk.co.caprica.vlcj.player.embedded.videosurface.VideoSurface;

/**
 *
 * @author LH
 */
public class StreamGUI
{
    private final int width = iZstreamer.width;

    private final int height = iZstreamer.height;
    boolean stopPlay = false;
    public MediaPlayer m=null;
    private boolean fs=true;
    private String url = "http://31.7.177.108:2294";//"D:\\mp3\\assorted Earworms\\22 - StarDisc - Fernando Pepe.flac";//
    public static StreamGUI player = new StreamGUI();
    private PlayerStructure thix;
    public void setPlayerStructure(PlayerStructure x)
    {
        thix=x;
    }
    VisualizedGUIOverlay vgui;
    private CanvasVideoSurface v;
    private Canvas lc = null;
    public void play()
    {
        //if(m==null)
        if(fs)
        {
            String vpath = new File(Player.class.getProtectionDomain().
                                getCodeSource().getLocation().getPath()).getParent()+"\\vis\\";
            System.out.println(vpath);
            
            
            
           Canvas s = thix.getBackGround();
            if(s!=null&&s!=lc)
            {
                 MediaPlayerFactory mpf = new MediaPlayerFactory("--projectm-preset-path="+vpath,"--audio-visual=projectM");
                  m = mpf.newEmbeddedMediaPlayer();
                  v=mpf.newVideoSurface(s);
                 ((EmbeddedMediaPlayer)m).setVideoSurface(v);
                 //vgui=new VisualizedGUIOverlay(this,(JFrame)thix);
                 //((EmbeddedMediaPlayer)m).setOverlay(vgui);
                 //((EmbeddedMediaPlayer)m).enableOverlay(true);
            }
            else
            {
                MediaPlayerFactory mpf = new MediaPlayerFactory();
                m = mpf.newHeadlessMediaPlayer();
            }
            m.startMedia(url);
            
            fs=true;
            lc=s;
        }
        else
        {
            m.play();
        }
        new Thread(()->{
        while(!stopPlay)
        {
            String tit = m.getMediaMeta().getTitle();
            thix.setPlaying(tit);
            try
            {
                Thread.sleep(50);
            }
            catch (InterruptedException ex)
            {
                ex.printStackTrace();
            }
        }
        m.pause();
        stopPlay=false;//ARSCHFOTZE!
        }).start();
        
        
    }
    
}
